// ConaitoObject.cpp: implementation of the CConaitoObject class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "VCSample.h"
#include "ConaitoObject.h"
#include "VCSampleDlg.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CConaitoObject::CConaitoObject()
{

}

CConaitoObject::~CConaitoObject()
{

}

void CConaitoObject::OnRegisteration(CString sUniqueId, CString sParam1,CString sParam2,CString sParam3,CString sParam4, CString sParam5, CString sFromIP, UINT nFromPort, CString sLocalIP, UINT nLocalPort)
{
	SendParamValueReturned(1001, "Param Value",sFromIP, nFromPort);
	RegistrationDone(sUniqueId, sParam1, sParam2, sParam3, sParam4, sParam5, sFromIP, nFromPort, sLocalIP, nLocalPort);
}


void CConaitoObject::OnUnRegisteration(CString sUniqueId)
{



}


void CConaitoObject::OnConnectionLost(CString sUniqueId)
{



}

void CConaitoObject::OnServerTextMsg(CString sFromUniqueId, CString sTextMsg)
{

	CVCSampleDlg* pParentWnd = (CVCSampleDlg*) AfxGetMainWnd();
	pParentWnd->m_sReceiveClientText.AddString(sFromUniqueId + ": " + sTextMsg);

}


void CConaitoObject::OnTextMsg(CString sFromUniqueId, CString sToUniqueId, CString sTextMsg)
{
	
	CVCSampleDlg* pParentWnd = (CVCSampleDlg*) AfxGetMainWnd();
	pParentWnd->m_ListMonitorText.AddString("From: " + sFromUniqueId + " To: " + sToUniqueId + " :: " + sTextMsg);


}



/**********************************************************************
																																		  *
	NOTE:																															  *
		To Set the Voice through Proxy the event handler are given below:	*
																																		  *
***********************************************************************


void CConaitoObject::OnConversationConnected(DWORD dwEventHandle, CString sFromUniqueId, CString sToUniqueId)
{
	SetVoiceStreamThroughProxy(dwEventHandle);
}

void CConaitoObject::OnConversationAccepted(DWORD dwEventHandle, CString sFromUniqueId, CString sToUniqueId)
{
	SetVoiceStreamThroughProxy(dwEventHandle);
}

void CConaitoObject::OnConferenceConnected(DWORD dwEventHandle, CString sFromUniqueId, CString sToUniqueId)
{
	SetVoiceStreamThroughProxy(dwEventHandle);
}

void CConaitoObject::OnConferenceAccepted(DWORD dwEventHandle, CString sFromUniqueId, CString sToUniqueId)
{
	SetVoiceStreamThroughProxy(dwEventHandle);
}

void CConaitoObject::OnAddConference(DWORD dwEventHandle, CString sFromUniqueId, CString sToUniqueId, CString sAddConfUniqueId)
{
	SetVoiceStreamThroughProxy(dwEventHandle);
}

*/

/**********************************************************************
																																		  *
	NOTE:																															  *
		To Set the Voice without Proxy the event handler are given below:	*
																																		  *
************************************************************************/


void CConaitoObject::OnConversationConnected(DWORD dwEventHandle, CString sFromUniqueId, CString sToUniqueId)
{
	
	CString sFromRemoteIP = GetRegisteredClientRemoteIP(sFromUniqueId);
	CString sToRemoteIP = GetRegisteredClientRemoteIP(sToUniqueId);

	CString sIP = _T("");
	UINT nPort = 0;
		
	if(sFromRemoteIP == sToRemoteIP)
	{
		sIP = GetRegisteredClientLocalIP(sFromUniqueId);
		nPort = GetRegisteredClientLocalPort(sFromUniqueId);
	}
	else
	{
		sIP = GetRegisteredClientRemoteIP(sFromUniqueId);
		nPort = GetRegisteredClientRemotePort(sFromUniqueId);
	}

	SetVoiceStreamIPPort(dwEventHandle, sIP, nPort);
	
}

void CConaitoObject::OnConversationAccepted(DWORD dwEventHandle, CString sFromUniqueId, CString sToUniqueId)
{
	
	CString sFromRemoteIP = GetRegisteredClientRemoteIP(sFromUniqueId);
	CString sToRemoteIP = GetRegisteredClientRemoteIP(sToUniqueId);

	CString sIP = _T("");
	UINT nPort = 0;
		
	if(sFromRemoteIP == sToRemoteIP)
	{
		sIP = GetRegisteredClientLocalIP(sFromUniqueId);
		nPort = GetRegisteredClientLocalPort(sFromUniqueId);
	}
	else
	{
		sIP = GetRegisteredClientRemoteIP(sFromUniqueId);
		nPort = GetRegisteredClientRemotePort(sFromUniqueId);
	}

	SetVoiceStreamIPPort(dwEventHandle, sIP, nPort);

}

void CConaitoObject::OnConferenceConnected(DWORD dwEventHandle, CString sFromUniqueId, CString sToUniqueId)
{

	CString sFromRemoteIP = GetRegisteredClientRemoteIP(sFromUniqueId);
	CString sToRemoteIP = GetRegisteredClientRemoteIP(sToUniqueId);

	CString sIP = _T("");
	UINT nPort = 0;
		
	if(sFromRemoteIP == sToRemoteIP)
	{
		sIP = GetRegisteredClientLocalIP(sFromUniqueId);
		nPort = GetRegisteredClientLocalPort(sFromUniqueId);
	}
	else
	{
		sIP = GetRegisteredClientRemoteIP(sFromUniqueId);
		nPort = GetRegisteredClientRemotePort(sFromUniqueId);
	}

	SetVoiceStreamIPPort(dwEventHandle, sIP, nPort);
	
}

void CConaitoObject::OnConferenceAccepted(DWORD dwEventHandle, CString sFromUniqueId, CString sToUniqueId)
{
	
	CString sFromRemoteIP = GetRegisteredClientRemoteIP(sFromUniqueId);
	CString sToRemoteIP = GetRegisteredClientRemoteIP(sToUniqueId);

	CString sIP = _T("");
	UINT nPort = 0;
		
	if(sFromRemoteIP == sToRemoteIP)
	{
		sIP = GetRegisteredClientLocalIP(sFromUniqueId);
		nPort = GetRegisteredClientLocalPort(sFromUniqueId);
	}
	else
	{
		sIP = GetRegisteredClientRemoteIP(sFromUniqueId);
		nPort = GetRegisteredClientRemotePort(sFromUniqueId);
	}

	SetVoiceStreamIPPort(dwEventHandle, sIP, nPort);
}

void CConaitoObject::OnAddConference(DWORD dwEventHandle, CString sFromUniqueId, CString sToUniqueId, CString sAddConfUniqueId)
{

	/****************************************************
		Impotent Note:

		Here, you can see we are getting IP & Port of the client
		which is being added (sAddConfUniqueId) into the conference, 
		not the client from which the request received (sFromUniqueId)

	*****************************************************/
	
	
	CString sAddConfRemoteIP = GetRegisteredClientRemoteIP(sAddConfUniqueId);
	CString sToRemoteIP = GetRegisteredClientRemoteIP(sToUniqueId);

	CString sIP = _T("");
	UINT nPort = 0;
		
	if(sAddConfRemoteIP == sToRemoteIP)
	{
		sIP = GetRegisteredClientLocalIP(sAddConfUniqueId);
		nPort = GetRegisteredClientLocalPort(sAddConfUniqueId);
	}
	else
	{
		sIP = GetRegisteredClientRemoteIP(sAddConfUniqueId);
		nPort = GetRegisteredClientRemotePort(sAddConfUniqueId);
	}

	SetVoiceStreamIPPort(dwEventHandle, sIP, nPort);

}


